/**
 * noconsole
 *
 * Tool to start programs in Windows NT and Windows 95/98 without bringing up a 
 * windows console.
 *
 * Usage:
 *     noconsole "command line"
 *            If command line consists of multiple words, put them in 
 *            double quotes.
 *
 * File:    noconsole.c
 * Author:  Tanmay K. Mohapatra
 * E-Mail:  tanmaykm@netscape.net
 * HTTP:    http://members.tripod.com/~tanmaykm/
 *          http://tanmaykm.webjump.com/
 *
 */

#include <windows.h>
#include <stdio.h>

int main(int argc, char **argv)
{
    STARTUPINFO         stStartUp;
    PROCESS_INFORMATION stProcInfo;

    if (argc < 2)
    {
        fprintf(stderr, "Usage: noconsole \"command line\"\n");
        return 1;
    }

    memset (&stStartUp, 0, sizeof (stStartUp));
    stStartUp.cb = sizeof(stStartUp);

    if (!CreateProcess (NULL, argv[1], NULL, NULL, TRUE, DETACHED_PROCESS, NULL, NULL, &stStartUp, &stProcInfo))
    {
        LPTSTR  pCompleteErrMsg;
        HRESULT hResult;

        hResult = GetLastError();
        FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM,
            NULL, hResult,
            MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
            (LPTSTR)&pCompleteErrMsg,
            0, NULL);

        fprintf(stderr, "Error starting %s (Error %d): %s", argv[1], hResult, pCompleteErrMsg);
        LocalFree (pCompleteErrMsg);
        return -1;
    }
    printf("noconsole started \"%s\"", argv[1]);
    return 0;
}

/* test program

int main(void)
{
    while(1)
    {
        Sleep(2000);
        printf("Hello\n");
    }
    return 0;
}
*/
